package quq.ots.example;

import java.sql.ResultSet;
import java.sql.Statement;

import javax.sql.XAConnection;

import org.omg.CosNaming.Binding;
import org.omg.CosNaming.BindingIteratorHolder;
import org.omg.CosNaming.BindingListHolder;
import org.omg.CosNaming.NameComponent;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAManager;

import quq.ots.example.util.Util;

import com.arjuna.ArjunaOTS.ArjunaFactoryHelper;

public class Participant2 {

	org.omg.CORBA.ORB orb;
	org.omg.CORBA.Object obj;
	org.omg.CosTransactions.Control control;
	org.omg.CosTransactions.Terminator terminator;
	org.omg.CosTransactions.Coordinator coordinator;
	org.omg.CosTransactions.PropagationContext propogationCtx;
	org.omg.PortableServer.POAManager poaman;
	org.omg.PortableServer.POA poa;
	com.arjuna.ArjunaOTS.ArjunaFactory TSFactory;
	quq.ots.example.resource.OracleResourceManager rm;

	java.util.Properties props = System.getProperties();

	Participant2() {
		try {
			System.out.println("Initializing Participant 2 ORB & JTS...");
			String args[] = { "-ORBInitRef NameService=corbaname::localhost:9101" };
			Class.forName("org.jacorb.orb.ORB");
			Class.forName("org.jacorb.orb.ORBSingleton");
			props.setProperty("org.omg.CORBA.ORBClass", "org.jacorb.orb.ORB");
			props.setProperty("org.omg.CORBA.ORBSingletonClass",
					"org.jacorb.orb.ORBSingleton");
			props.setProperty("jacorb.home", Util.get_JACORB_HOME());

			orb = org.omg.CORBA.ORB.init(args, props);

			org.omg.CORBA.Object obj = orb
					.resolve_initial_references("RootPOA");
			POA poa = org.omg.PortableServer.POAHelper.narrow(obj);

			// ServantManager pman = poa.get_servant_manager();
			POAManager poaman = poa.the_POAManager();
			poaman.activate();

			org.omg.CORBA.Object nameObj = orb
					.resolve_initial_references("NameService");

			NamingContextExt rootContext = NamingContextExtHelper
					.narrow(nameObj);
			if (rootContext == null) {
				System.out.println("-----Can not find NameService");
				return;
			} else {
				System.out.println("-----Found NameService");
				System.out.println("-----Found NameService:"
						+ rootContext.toString());

			}
			org.omg.CosNaming.BindingListHolder bl = new BindingListHolder();
			org.omg.CosNaming.BindingIteratorHolder bi = new BindingIteratorHolder();
			rootContext.list(100, bl, bi);

			for (int i = 0; i < bl.value.length; i++) {
				Binding binding = bl.value[i];
				System.out.println("-----Binding Type:" + binding.binding_type);
				for (int j = 0; j < binding.binding_name.length; j++) {
					System.out.println("Binding name[" + j + "]:"
							+ binding.binding_name[j]);
				}

			}

			NameComponent name[] = new NameComponent[1];

			NameComponent name1 = new NameComponent(
					"TransactionManagerService", "OTS");
			name[0] = name1;
			org.omg.CORBA.Object tsObj = null;
			try {
				tsObj = rootContext.resolve(rootContext
						.to_name("TransactionManagerService.OTS"));
				System.out.println("-----Found TransactionManagerService:"
						+ tsObj.toString());
			} catch (Exception e) {
				e.printStackTrace();
				tsObj = rootContext.resolve(name);
			}
			// org.omg.CORBA.Object tsObj = rootContext.resolve(name);
			if (tsObj == null) {
				System.out.println("TransactionManagerService not found");
				return;
			}
			TSFactory = ArjunaFactoryHelper.narrow(tsObj);
			System.out.println("-----Found TransactionManagerService:"
					+ TSFactory.toString());

			rm = new quq.ots.example.resource.OracleResourceManager(
					"jdbc:oracle:thin:@192.168.65.248:1521:ce002", "qsh", "qsh");

			System.out.println("Participant 2 started");

		} catch (Exception e) {
			System.out
					.println("Exception during Participant 2 initialization: "
							+ e.getMessage());
			e.printStackTrace();
		}
	}

	void destroy() throws Exception {
		System.out.println("Destroying Participant 2 ORB...");
		orb.destroy();
		System.out.println("Participant 2 ORB destroyed.");
	}

	void enlistResource() {

	}

	String updateAccount(
			org.omg.CosTransactions.PropagationContext propogationCtx,
			String act, double amt) {
		System.out.println("Updating Account for Participant 2...");
		XAConnection xaConn = null;
		Statement stmtCheckAcct = null;
		ResultSet rset = null;
		Statement stmtUpdateBalance = null;
		try {
			coordinator = propogationCtx.current.coord;
			org.omg.CosTransactions.otid_t otid = coordinator.get_txcontext().current.otid;
			System.out.println("status: "
					+ TSFactory.getCurrentStatus(propogationCtx.current.otid));
			// com.tibco.swat.txn.sample.resource.OracleResource res
			// = new com.tibco.swat.txn.sample.resource.OracleResource(rm,
			// otid);

			byte[] gid = new byte[64];
			gid[0] = (byte) 1;

			byte[] bqid = new byte[64];
			bqid[0] = (byte) 2;

			quq.ots.example.resource.OracleResource res = new quq.ots.example.resource.OracleResource(
					rm, otid, new byte[] { 2 });

			obj = orb.resolve_initial_references("RootPOA");
			poa = org.omg.PortableServer.POAHelper.narrow(obj);
			poaman = poa.the_POAManager();
			poaman.activate();
			poa.activate_object(res);
			org.omg.CosTransactions.Resource otsRes = org.omg.CosTransactions.ResourceHelper
					.narrow(poa.servant_to_reference(res));
			System.out.println("Registering Oracle Resource...");
			coordinator.register_resource(otsRes);
			System.out.println("Oracle Resource registered.");
			String sqlCheckAcct = "select status,balance from Account where name='vs'";
			String sqlUpdateBalance = "update Account set balance = balance + ("
					+ amt + ") , " + "count = count + 1 where name='vs'";
			System.out.println("sqlCheckAcct for " + "" + ":" + sqlCheckAcct);
			System.out.println("sqlUpdateBalance for " + "" + ":"
					+ sqlUpdateBalance);
			xaConn = res.xaConn;
			stmtCheckAcct = xaConn.getConnection().createStatement();
			rset = stmtCheckAcct.executeQuery(sqlCheckAcct);
			stmtUpdateBalance = xaConn.getConnection().createStatement();
			int ret = stmtUpdateBalance.executeUpdate(sqlUpdateBalance);

			// int rowCount =rset->getNumArrayRows();

			/*
			 * int rowCount = 0; while (rset.next()) { rowCount++; if (rowCount
			 * > 1) { throw new BusinessException("ERR_99",
			 * "Here has two row for Account[" + accountName + "]."); } String
			 * status = rset.getString(1); double balance = rset.getInt(2);
			 * System.out.println("Acount [" + accountName.getStringValue() +
			 * "]Status is " + status); System.out.println("Acount [" +
			 * accountName.getStringValue() + "],the Balance is " + balance);
			 * System.out.println("Acount [" + accountName.getStringValue() +
			 * "],the Account is " + transferAmount.getDoubleValue()); if
			 * (!status.equalsIgnoreCase("OK")) { System.out.println("Acount ["
			 * + accountName.getStringValue() + "]Status is Error"); throw new
			 * AccountInvalidException(accountName .getStringValue(), BANK_NAME,
			 * status); } if ((-transferAmount.getDoubleValue()) > balance) {
			 * System.out.println("Acount [" + accountName +
			 * "]transfer amount larger then balance"); throw new
			 * InsufficientBalanceException(accountName .getStringValue(),
			 * BANK_NAME, balance, -transferAmount.getDoubleValue() ); } }
			 * System.out.println("Acount [" + accountName.getStringValue() +
			 * "],the Row Count is " + rowCount); if (rowCount < 1) { throw new
			 * AccountNonexistentException(accountName .getStringValue(),
			 * BANK_NAME); }
			 * 
			 * 
			 * stmtUpdateBalance = xaConn.getConnection().createStatement(); int
			 * ret=stmtUpdateBalance.executeUpdate(sqlUpdateBalance); if(ret !=
			 * 1) { throw new BusinessException("ERR_99",
			 * "Here has no row for Account[" + accountName + "]."); }
			 */

			return "SUCCESS: Change Balance completed!";

		} catch (Exception e) {
			System.out.println("Exception: " + e.getMessage());
			e.printStackTrace(System.out);
			return "ERROR: Change Balance Aborted..." + "\n" + e.toString();
			// result.setCode("ERR_SYS");
			// result.setMsg(e.toString());
		} finally {
			/*
			 * try { rset.close(); stmtCheckAcct.close();
			 * stmtUpdateBalance.close(); xaConn.close(); } catch (Exception e)
			 * { System.out.println("Exception in updating Participant 2: " +
			 * e.getMessage()); e.printStackTrace(System.out); }
			 */
		}
	}
}
